Index: trunk/expeditee/documentation/simpletest/simpletest.8
===================================================================
--- trunk/expeditee/documentation/simpletest/simpletest.8	(revision 112)
+++ trunk/expeditee/documentation/simpletest/simpletest.8	(revision 113)
@@ -1,9 +1,9 @@
 +v+ 22
-+V+ 2
-+p+ UWW
++V+ 4
++p+ 4
 +U+ ra33
 +D+ 22Jan2008:1249
 +M+ root
-+d+ 05Jun2008:1015
++d+ 26Jun2008:0057
 +A+ SimpleTest8
 
@@ -48,12 +48,6 @@
 +T+ @This is an annotation item
 +Z+
-ActiveTime:00:00:12
+ActiveTime:00:00:01
 DarkTime:00:00:00
-00:06:313 81 4 Md
-00:06:440 81 4 Mu
-00:07:553 84 33 Md
-00:07:568 84 33 Rd
-00:08:988 75 3 Md
-00:09:151 75 3 Mu
-00:09:719 71 31 Md
-00:09:853 71 31 Mu
+00:00:950 153 52 Ld
+00:01:060 154 52 Lu
Index: trunk/expeditee/documentation/simpletestsuite/303.exp
===================================================================
--- trunk/expeditee/documentation/simpletestsuite/303.exp	(revision 113)
+++ trunk/expeditee/documentation/simpletestsuite/303.exp	(revision 113)
@@ -0,0 +1,71 @@
+V 3
+p 4
+U root
+D 25Jun2008:1830
+M root
+d 25Jun2008:1830
+Z
+
+S T 12
+s 25Jun2008:1830
+d 0 0 100
+P 34 49
+f sb41
+T @TestFrame
+
+S T 13
+s 25Jun2008:1830
+P 119 141
+T Item
+
+S T 16
+s 25Jun2008:1830
+P 128 216
+T Item
+
+S T 18
+s 25Jun2008:1830
+P 122 287
+T Item
+
+S T 20
+s 25Jun2008:1830
+P 120 362
+T Item
+
+S T 21
+s 25Jun2008:1830
+P 134 432
+T Item
+
+S T 5
+s 25Jun2008:1830
+P 940 572
+F 89
+T @ao
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:00:14
+DarkTime:00:00:00
+00:03:530 119 141 kShift
+00:04:080 119 141 kI
+00:04:327 125 141 kT
+00:04:387 132 141 kE
+00:04:529 141 141 kM
+00:05:699 128 132 Rd
+00:05:786 128 132 Ru
+00:06:198 137 207 Rd
+00:06:316 137 207 Ru
+00:06:781 131 278 Rd
+00:06:896 131 278 Ru
+00:08:324 129 353 Rd
+00:08:425 129 353 Ru
+00:09:362 143 423 Md
+00:09:501 143 423 Mu
+00:12:790 351 251 Ld
+00:12:881 351 251 Lu
Index: trunk/expeditee/documentation/simpletestsuite/305.exp
===================================================================
--- trunk/expeditee/documentation/simpletestsuite/305.exp	(revision 113)
+++ trunk/expeditee/documentation/simpletestsuite/305.exp	(revision 113)
@@ -0,0 +1,44 @@
+V 3
+p 4
+U root
+D 25Jun2008:1932
+M root
+d 25Jun2008:1932
+Z
+
+S T 12
+s 25Jun2008:1932
+d 0 0 100
+P 34 49
+f sb41
+T @StageFrame
+
+S T 5
+s 25Jun2008:1932
+P 940 572
+F 89
+T @ao
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:00:18
+DarkTime:00:00:00
+00:07:051 256 21 Md
+00:08:016 214 239 Md
+00:08:151 214 239 Mu
+00:08:803 356 330 Md
+00:08:896 356 330 Mu
+00:09:696 501 208 Md
+00:09:722 501 208 Rd
+00:10:497 314 244 Md
+00:10:612 314 244 Mu
+00:11:129 337 188 Md
+00:11:207 337 188 Mu
+00:16:314 325 193 Md
+00:16:333 325 193 Rd
+00:16:845 319 222 Ld
+00:16:988 319 222 Lu
Index: trunk/expeditee/documentation/simpletestsuite/306.exp
===================================================================
--- trunk/expeditee/documentation/simpletestsuite/306.exp	(revision 113)
+++ trunk/expeditee/documentation/simpletestsuite/306.exp	(revision 113)
@@ -0,0 +1,29 @@
+V 3
+p 4
+U root
+D 25Jun2008:2020
+M root
+d 25Jun2008:2020
+Z
+
+S T 12
+s 25Jun2008:2020
+d 0 0 100
+P 34 49
+f sb38
+T AssertEquals $s.expectedValue $s.value
+
+S T 5
+s 25Jun2008:2020
+P 940 572
+F 89
+T @ao
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:00:03
+DarkTime:00:00:00
Index: trunk/expeditee/documentation/simpletestsuite/308.exp
===================================================================
--- trunk/expeditee/documentation/simpletestsuite/308.exp	(revision 113)
+++ trunk/expeditee/documentation/simpletestsuite/308.exp	(revision 113)
@@ -0,0 +1,22 @@
+V 52
+p 4
+U root
+D 25Jun2008:2021
+M root
+d 27Jun2008:1639
+Z
+
+S T 237
+s 27Jun2008:1639
+P 200 200
+T ActiveTime:00:00:00
+T DarkTime:00:00:00
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:02:29
+DarkTime:00:00:00
Index: trunk/expeditee/documentation/simpletestsuite/315.exp
===================================================================
--- trunk/expeditee/documentation/simpletestsuite/315.exp	(revision 113)
+++ trunk/expeditee/documentation/simpletestsuite/315.exp	(revision 113)
@@ -0,0 +1,80 @@
+V 42
+p 4
+U root
+D 26Jun2008:0001
+M root
+d 27Jun2008:1204
+Z
+
+S T 12
+s 26Jun2008:0001
+d 0 0 100
+P 34 49
+X DebugFrame
+f sb41
+T @DebugProcedureTest
+
+S T 119
+s 26Jun2008:0016
+P 45 116
+T Set $s. "FirstMessage"
+
+S T 130
+s 26Jun2008:0017
+P 401 154
+X DebugFrame 0.3
+T @DebugFrame 0.3
+
+S T 117
+s 26Jun2008:0016
+P 49 157
+T MessageLn
+
+S T 115
+s 26Jun2008:0001
+d 0 70 0
+P 48 199
+F 316
+T //This is a comment
+
+S T 143
+s 27Jun2008:1141
+d 50 50 50
+P 404 215
+X DebugFrame
+T @DebugFrame
+
+S T 114
+s 26Jun2008:0002
+P 51 247
+T Messageln $s.message
+
+S T 5
+s 26Jun2008:0001
+P 940 572
+F 89
+T @ao
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:24:14
+DarkTime:00:22:15
+00:01:158 430 264 kCtrl
+00:01:327 430 264 kSpace
+00:01:748 430 264 kSpace
+00:02:242 430 264 kSpace
+00:02:711 430 264 kSpace
+00:03:422 430 264 kSpace
+00:03:976 430 264 kSpace
+00:04:622 430 264 kSpace
+00:05:258 430 264 kSpace
+00:10:574 477 254 Md
+00:10:700 477 254 Mu
+00:11:728 475 203 Md
+00:11:848 475 203 Mu
+00:15:734 471 144 Ld
+00:15:881 471 144 Lu
Index: trunk/expeditee/documentation/simpletestsuite/316.exp
===================================================================
--- trunk/expeditee/documentation/simpletestsuite/316.exp	(revision 113)
+++ trunk/expeditee/documentation/simpletestsuite/316.exp	(revision 113)
@@ -0,0 +1,44 @@
+V 7
+p 4
+U root
+D 26Jun2008:0001
+M root
+d 26Jun2008:0015
+Z
+
+S T 12
+s 26Jun2008:0001
+d 0 0 100
+P 34 49
+F 318
+f sb41
+T //This is a comment
+
+S T 13
+s 26Jun2008:0001
+d 0 70 0
+P 52 131
+F 317
+T //This is another comment
+
+S T 14
+s 26Jun2008:0002
+P 50 219
+T MessageLn $s.message
+
+S T 5
+s 26Jun2008:0001
+P 940 572
+F 89
+T @ao
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:00:27
+DarkTime:00:00:00
+00:00:904 148 108 Ld
+00:00:995 148 108 Lu
Index: trunk/expeditee/documentation/simpletestsuite/317.exp
===================================================================
--- trunk/expeditee/documentation/simpletestsuite/317.exp	(revision 113)
+++ trunk/expeditee/documentation/simpletestsuite/317.exp	(revision 113)
@@ -0,0 +1,101 @@
+V 3
+p 4
+U root
+D 26Jun2008:0001
+M root
+d 26Jun2008:0002
+Z
+
+S T 12
+s 26Jun2008:0001
+d 0 0 100
+P 34 49
+f sb41
+T //This is another comment
+
+S T 13
+s 26Jun2008:0002
+P 34 140
+T Set $s.message "Test message"
+
+S T 15
+s 26Jun2008:0002
+P 34 176
+T MessageLn $s.message
+
+S T 5
+s 26Jun2008:0001
+P 940 572
+F 89
+T @ao
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:00:19
+DarkTime:00:00:00
+00:01:643 34 140 kShift
+00:01:765 34 140 kS
+00:01:938 44 140 kE
+00:02:011 53 140 kT
+00:02:205 60 140 kSpace
+00:02:771 66 140 kShift
+00:02:992 66 140 k4
+00:03:727 77 140 kS
+00:04:446 86 140 kPeriod
+00:04:876 91 140 kM
+00:04:978 108 140 kE
+00:05:119 117 140 kS
+00:05:287 126 140 kS
+00:05:410 135 140 kA
+00:05:554 145 140 kG
+00:05:602 155 140 kE
+00:06:992 165 140 kSpace
+00:07:238 170 140 kShift
+00:07:360 170 140 kQuote
+00:08:005 177 140 kShift
+00:08:160 177 140 kT
+00:08:280 189 140 kE
+00:08:400 199 140 kS
+00:08:490 208 140 kT
+00:08:639 215 140 kSpace
+00:08:859 220 140 kM
+00:08:919 237 140 kE
+00:09:011 247 140 kS
+00:09:225 256 140 kS
+00:09:345 265 140 kA
+00:09:457 275 140 kG
+00:09:547 285 140 kE
+00:09:922 295 140 kShift
+00:10:089 295 140 kQuote
+00:10:425 302 140 kEscape
+00:10:755 34 176 kShift
+00:10:870 34 176 kM
+00:11:033 49 176 kE
+00:11:139 59 176 kS
+00:11:323 68 176 kS
+00:11:474 77 176 kA
+00:11:544 87 176 kG
+00:11:658 97 176 kE
+00:12:642 107 176 kSpace
+00:13:132 112 176 kBackspace
+00:13:202 107 176 kShift
+00:13:372 107 176 kL
+00:13:774 117 176 kN
+00:13:966 128 176 kSpace
+00:14:496 134 176 kShift
+00:14:711 134 176 k4
+00:14:978 145 176 kS
+00:15:249 154 176 kPeriod
+00:15:739 158 176 kM
+00:15:804 175 176 kE
+00:15:914 185 176 kS
+00:16:105 194 176 kS
+00:16:222 203 176 kA
+00:16:341 213 176 kG
+00:16:431 223 176 kE
+00:17:560 218 256 Ld
+00:17:683 218 256 Lu
Index: trunk/expeditee/documentation/simpletestsuite/318.exp
===================================================================
--- trunk/expeditee/documentation/simpletestsuite/318.exp	(revision 113)
+++ trunk/expeditee/documentation/simpletestsuite/318.exp	(revision 113)
@@ -0,0 +1,31 @@
+V 4
+p 4
+U root
+D 26Jun2008:0008
+M root
+d 26Jun2008:0008
+Z
+
+S T 12
+s 26Jun2008:0008
+d 0 0 100
+P 34 49
+f sb41
+T //This is a comment
+
+S T 5
+s 26Jun2008:0008
+P 940 572
+F 89
+T @ao
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:00:03
+DarkTime:00:00:00
+00:00:877 377 125 Ld
+00:00:992 377 125 Lu