Index: trunk/expeditee/documentation/copyframeset/53.exp
===================================================================
--- trunk/expeditee/documentation/copyframeset/53.exp	(revision 386)
+++ trunk/expeditee/documentation/copyframeset/53.exp	(revision 386)
@@ -0,0 +1,47 @@
+V 4
+p 4
+U root
+D 26Jul2008:1144
+M root
+d 25Sep2008:1158
+Z
+
+S T 12
+s 26Jul2008:1144
+d 0 0 100
+P 34 49
+f sb41
+T @Frame
+
+S T 18
+s 26Jul2008:1146
+P 245 116
+T y = 5 + 5
+w 767
+
+S T 20
+s 26Jul2008:1146
+P 245 152
+T x = y * y
+w 767
+
+S T 22
+s 26Jul2008:1146
+P 245 188
+T z = 2 y + x
+w 767
+
+S T 5
+s 26Jul2008:1144
+P 940 572
+F 89
+T @ao
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:00:49
+DarkTime:00:00:00
Index: trunk/expeditee/documentation/copyframeset/frame.inf
===================================================================
--- trunk/expeditee/documentation/copyframeset/frame.inf	(revision 378)
+++ trunk/expeditee/documentation/copyframeset/frame.inf	(revision 386)
@@ -1,1 +1,1 @@
-CopyFrameset52
+CopyFrameset53
Index: trunk/expeditee/documentation/deletedframes/47.exp
===================================================================
--- trunk/expeditee/documentation/deletedframes/47.exp	(revision 386)
+++ trunk/expeditee/documentation/deletedframes/47.exp	(revision 386)
@@ -0,0 +1,22 @@
+V 2
+p 4
+D 25Sep2008:1158
+M root
+d 25Sep2008:1158
+Z
+
+S T 9
+s 25Sep2008:1158
+d 0 0 100
+P 13 50
+f mb38
+T SimpleTestFrameset
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:00:02
+DarkTime:00:00:00
Index: trunk/expeditee/documentation/deletedframes/48.exp
===================================================================
--- trunk/expeditee/documentation/deletedframes/48.exp	(revision 386)
+++ trunk/expeditee/documentation/deletedframes/48.exp	(revision 386)
@@ -0,0 +1,79 @@
+V 8
+p 4
+U root
+D 29Apr2008:1142
+M root
+d 25Sep2008:1158
+Z
+
+S T 38
+s 29Apr2008:1142
+d 0 0 100
+P 22 62
+X RunFrame
+f sb58
+T CopyFrameTest
+
+S T 4
+s 29Apr2008:1142
+P 70 133
+D 0
+f tr22
+T Set $s.frameName "SimpleTestSuite159"
+
+S T 5
+s 29Apr2008:1142
+d 0 0 0
+P 70 170
+T Set $s.destinationFrameset "FramesetThatDoesntExist"
+
+S T 34
+s 29Apr2008:1214
+d 0 0 0
+P 70 206
+T DeleteFrameset $s.destinationFrameset
+
+S T 33
+s 29Apr2008:1144
+d 0 0 0
+P 70 242
+T ReadFrame $s.FrameName $fp.Frame
+
+S T 32
+s 29Apr2008:1142
+d 0 0 0
+P 70 278
+T CopyFrame $fp.Frame $fp.Copy $s.destinationFrameset $b.success
+
+S T 31
+s 29Apr2008:1214
+d 0 0 0
+P 70 314
+T AssertTrue $b.success
+
+S T 79
+s 26Jul2008:1308
+d 0 0 0
+P 69 423
+T Set $s.destinationFrameset "BadFramesetName0"
+
+S T 85
+s 26Jul2008:1308
+d 0 0 0
+P 64 466
+T CopyFrame $fp.Frame $fp.Copy $s.destinationFrameset $b.success
+
+S T 90
+s 26Jul2008:1308
+d 0 0 0
+P 65 508
+T AssertFalse $b.success
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:01:32
+DarkTime:00:00:00
Index: trunk/expeditee/documentation/deletedframes/49.exp
===================================================================
--- trunk/expeditee/documentation/deletedframes/49.exp	(revision 386)
+++ trunk/expeditee/documentation/deletedframes/49.exp	(revision 386)
@@ -0,0 +1,34 @@
+V 4
+p 4
+U root
+D 18Sep2008:2222
+M Michael
+d 17Oct2008:0012
+O 0 0 0
+Z
+
+S T 3
+s 18Sep2008:2222
+d 0 0 100
+P 15 42
+T Gives instructions to users about how to improve technique
+Q 0
+f sb39
+
+S T 6
+s 17Oct2008:0012
+P 1010 343
+T DeleteFrame
+X DeleteFrame
+Q 0
+f tr18
+w 375
+
+Z
+
+Z
+
+Z
+
+ActiveTime:00:00:21
+DarkTime:00:00:00
Index: trunk/expeditee/documentation/deletedframes/frame.inf
===================================================================
--- trunk/expeditee/documentation/deletedframes/frame.inf	(revision 378)
+++ trunk/expeditee/documentation/deletedframes/frame.inf	(revision 386)
@@ -1,1 +1,1 @@
-DeletedFrames46
+DeletedFrames49
Index: trunk/expeditee/documentation/expediteetest/1.exp
===================================================================
--- trunk/expeditee/documentation/expediteetest/1.exp	(revision 378)
+++ trunk/expeditee/documentation/expediteetest/1.exp	(revision 386)
@@ -1,7 +1,7 @@
-V 29
+V 48
 p 4
 D 19Jul2008:1011
 M root
-d 18Sep2008:2308
+d 25Sep2008:1341
 Z
 
@@ -10,5 +10,5 @@
 d 0 0 100
 P 13 50
-F 19
+F 28
 f mb38
 T ExpediteeTest
@@ -20,8 +20,4 @@
 Z
 
-ActiveTime:00:29:04
+ActiveTime:00:30:34
 DarkTime:05:33:58
-00:01:067 13 48 Ld
-00:02:191 166 48 Lu
-00:03:294 13 48 Ld
-00:05:419 13 48 Lu
Index: trunk/expeditee/documentation/expediteetest/22.exp
===================================================================
--- trunk/expeditee/documentation/expediteetest/22.exp	(revision 386)
+++ trunk/expeditee/documentation/expediteetest/22.exp	(revision 386)
@@ -0,0 +1,43 @@
+V 1
+p 4
+U root
+D 25Sep2008:1159
+M root
+d 25Sep2008:1159
+Z
+
+S T 9
+s 25Sep2008:1159
+d 0 0 100
+P 13 50
+f mb38
+T ExpediteeTest
+
+S P 15
+s 25Sep2008:1159
+P 100 100
+h 2.0
+l 17
+
+S P 16
+s 25Sep2008:1159
+P 200 200
+j 17.0 0.5
+h 2.0
+l 17
+
+Z
+
+L 17 1
+s 15 16
+
+Z
+
+Z
+
+ActiveTime:00:00:03
+DarkTime:00:00:00
+00:02:894 100 100 Md
+00:02:894 100 100 Mu
+00:03:096 200 200 Md
+00:03:101 200 200 Mu
Index: trunk/expeditee/documentation/expediteetest/24.exp
===================================================================
--- trunk/expeditee/documentation/expediteetest/24.exp	(revision 386)
+++ trunk/expeditee/documentation/expediteetest/24.exp	(revision 386)
@@ -0,0 +1,43 @@
+V 1
+p 4
+U root
+D 25Sep2008:1159
+M root
+d 25Sep2008:1159
+Z
+
+S T 9
+s 25Sep2008:1159
+d 0 0 100
+P 13 50
+f mb38
+T ExpediteeTest
+
+S P 15
+s 25Sep2008:1159
+P 100 100
+h 2.0
+l 17
+
+S P 16
+s 25Sep2008:1159
+P 200 200
+j 17.0 0.5
+h 2.0
+l 17
+
+Z
+
+L 17 1
+s 15 16
+
+Z
+
+Z
+
+ActiveTime:00:00:03
+DarkTime:00:00:00
+00:02:993 100 100 Md
+00:02:993 100 100 Mu
+00:03:196 200 200 Md
+00:03:292 200 200 Mu
Index: trunk/expeditee/documentation/expediteetest/26.exp
===================================================================
--- trunk/expeditee/documentation/expediteetest/26.exp	(revision 386)
+++ trunk/expeditee/documentation/expediteetest/26.exp	(revision 386)
@@ -0,0 +1,43 @@
+V 1
+p 4
+U root
+D 25Sep2008:1200
+M root
+d 25Sep2008:1200
+Z
+
+S T 9
+s 25Sep2008:1200
+d 0 0 100
+P 13 50
+f mb38
+T ExpediteeTest
+
+S P 15
+s 25Sep2008:1200
+P 100 100
+h 2.0
+l 17
+
+S P 16
+s 25Sep2008:1200
+P 200 200
+j 17.0 0.5
+h 2.0
+l 17
+
+Z
+
+L 17 1
+s 15 16
+
+Z
+
+Z
+
+ActiveTime:00:00:02
+DarkTime:00:00:00
+00:02:493 100 100 Md
+00:02:493 100 100 Mu
+00:02:714 200 200 Md
+00:02:813 200 200 Mu
Index: trunk/expeditee/documentation/expediteetest/28.exp
===================================================================
--- trunk/expeditee/documentation/expediteetest/28.exp	(revision 386)
+++ trunk/expeditee/documentation/expediteetest/28.exp	(revision 386)
@@ -0,0 +1,43 @@
+V 1
+p 4
+U root
+D 25Sep2008:1201
+M root
+d 25Sep2008:1201
+Z
+
+S T 9
+s 25Sep2008:1201
+d 0 0 100
+P 13 50
+f mb38
+T ExpediteeTest
+
+S P 15
+s 25Sep2008:1201
+P 100 100
+h 2.0
+l 17
+
+S P 16
+s 25Sep2008:1201
+P 200 200
+j 17.0 0.5
+h 2.0
+l 17
+
+Z
+
+L 17 1
+s 15 16
+
+Z
+
+Z
+
+ActiveTime:00:00:01
+DarkTime:00:00:00
+00:01:495 100 100 Md
+00:01:496 100 100 Mu
+00:01:700 200 200 Md
+00:01:704 200 200 Mu
Index: trunk/expeditee/documentation/expediteetest/frame.inf
===================================================================
--- trunk/expeditee/documentation/expediteetest/frame.inf	(revision 378)
+++ trunk/expeditee/documentation/expediteetest/frame.inf	(revision 386)
@@ -1,1 +1,1 @@
-ExpediteeTest19
+ExpediteeTest28